=== packages/stk/stk_middle_mesh_util/CMakeLists.txt ===

STK_SUBPACKAGE(Middle_mesh_util)

ADD_SUBDIRECTORY(stk_middle_mesh_util)

STK_SUBPACKAGE_POSTPROCESS()
