=== packages/epetra/doc/OskiInterface/Makefile ===
all:
	pdflatex EpetraOskiInterface
	bibtex   EpetraOskiInterface
	pdflatex EpetraOskiInterface
	pdflatex EpetraOskiInterface
clean:
	@rm -f EpetraOskiInterface.aux
	@rm -f EpetraOskiInterface.log
	@rm -f EpetraOskiInterface.dvi
	@rm -f EpetraOskiInterface.bbl
	@rm -f EpetraOskiInterface.blg
	@rm -f EpetraOskiInterface.pdf
