=== packages/epetraext/test/Permutation/CMakeLists.txt ===



TRIBITS_ADD_EXECUTABLE_AND_TEST(
  Permutation_test
  SOURCES cxx_main.cpp
  ARGS -v
  COMM serial mpi
  )
